/* unix-niftp lib/gen/dbdget.c $Revision: 5.6 $ $Date: 1991/06/07 17:00:30 $ */
/*
 * $Log: dbdget.c,v $
 * Revision 5.6  1991/06/07  17:00:30  pb
 * Distribution of Oct90deslib+PPaids: Include des/lib/ and a few aids for PP sites
 *
 * Revision 5.5  90/08/01  13:34:12  pb
 * Distribution of Aug90RealPP+sequent: Full PP release and support for Sequent X.25 board
 * 
 * Revision 5.2  89/01/13  14:42:57  pb
 * Distribution of Jan89SuckMail: Support Sucking of mail
 * 
 * Revision 5.0  87/03/23  03:35:25  bin
 * Merger of latest UCL and Nottingham versions together with
 * an extensive spring clean.
 * Now UNIX-NIFTP prerelease.
 * 
 */
#include "db.h"
#include "nrs.h"

#ifndef ENOUGH
#define ENOUGH  150
#endif

static  domin_entry     dom;
static  char    dombuf[ENOUGH];

domin_entry *
domin_get(name)
char    *name;
{
	register char   *p, *q, *r;
	datum   fkey;
	datum   dat;
	char    xbuf[BUFSIZ];
	int     once;

	if(!_dbase_inuse && dbase_start() < 0)
		return(0);
	for(p = name, q = xbuf ; (*q = *p++) != NULL ; q++)
		if(*q >= 'A' && *q <= 'Z')
			*q += 'a' - 'A';
	fkey.dptr = xbuf;
	fkey.dsize = p - name;

	dat = fetch(fkey);
	if( (p = dat.dptr) == 0)
		return(0);
	for(once = 0; *p != '@' ; once++){
		switch(*p){
		case '>':
			for(q = xbuf, r = dat.dptr+1 ; (*q++ = *r++) != NULL;) continue;
			fkey.dptr = xbuf;
			fkey.dsize = dat.dsize-1;
			dat = fetch(fkey);
			if((p = dat.dptr) == 0)
				return(0);
			if(*p == '@' || !once)
				continue;
			fprintf(stderr,"corrupt entry for %s\n", name);
			return(0);
		case '$':
		case '#':
			/*
			 * a host entry - ignore
			 */
			return(0);
		default:
			/*
			 * for now just report error
			 */
			fprintf(stderr, "bad key for %s <%d>\n",
							name,*p&0377);
			return(0);
		}
	}
	dom.domin_name = q = dombuf;
	for(r = xbuf ; (*q++ = *r++) != NULL;) continue;   /* copy over */
	for(dom.domin_host = q, p++; (*q++ = *p++) != NULL;) continue;
	return(&dom);
}
